/*
* Copyright (C) 2013 Symphony Teleca Corp.
*
* Contact: Souparna Lodh <souparna.lodh(at)symphonyteleca.com>
*	
*
* DOUBANGO is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*	
* DOUBANGO is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*	
* You should have received a copy of the GNU General Public License
* along with DOUBANGO.
*
*/

/**@file tdav_codec_fsl_amr.h
 * @brief AMR-NB and AMR-WB codecs.
 * RTP payloader/depayloader are based on RFC 4867
 *
 * @author Souparna Lodh <souparna.lodh(at)symphonyteleca.com>
 *

 */
#ifndef TINYDAV_CODEC_FSL_AMR_H
#define TINYDAV_CODEC_FSL_AMR_H

#include "tinydav_config.h"

#include "tinymedia/tmedia_codec.h"

TDAV_BEGIN_DECLS

TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_amrnb_oa_plugin_def_t;
TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_amrnb_be_plugin_def_t;

TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_amrwb_oa_plugin_def_t;
TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_amrwb_be_plugin_def_t;

TDAV_END_DECLS

#endif /* TINYDAV_CODEC_FSL_AMR_H */
