/*
* Copyright (C) 2013 Symphony Teleca <http://www.symphonyteleca.com>.
*
* Contact: Mohammed Hasan <Mohammed(DOT)Hasan(at)symphonyteleca(DOT)com>
*/

/**@file tdav_codec_h263_hw_vpu.h
 * @brief H.263-1996 and H.263-1998 codec plugin using FSL VPU for encoding and decoding.
 * RTP payloader follows RFC 4629 for H263+ and RFC 2190 for H263.
 *
 * @author Mohammed Hasan <Mohammed(DOT)Hasan(at)symphonyteleca(DOT)com>
 *
 */
#ifndef TINYDAV_CODEC_H263_HW_VPU_H
#define TINYDAV_CODEC_H263_HW_VPU_H

#include "tinydav_config.h"

#if HAVE_FFMPEG

#include "tinymedia/tmedia_codec.h"

TDAV_BEGIN_DECLS


TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_h263_hw_vpu_plugin_def_t;
TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_h263p_hw_vpu_plugin_def_t;
TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_h263pp_hw_vpu_plugin_def_t;

TDAV_END_DECLS

#endif /* HAVE_FFMPEG */

#endif /* TINYDAV_CODEC_H263_HW_VPU_H */
