/*
* Copyright (C) 2013 Symphony Teleca Corp.
*
* Contact: Souparna Lodh <souparna(dot)lodh(at)symphonyteleca.com>
*	
* This file is part of Open Source Doubango Framework.
*
* DOUBANGO is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*	
* DOUBANGO is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*	
* You should have received a copy of the GNU General Public License
* along with DOUBANGO.
*
*/

/**@file tdav_codec_fsl_vpu_h264.h
 * @brief H.264 codec plugin using Freescale VPU HW codec Interface
 * RTP payloader/depayloader follows RFC 3984.
 *
 * @author Souparna Lodh <souparna(dot)lodh(at)symphonyteleca.com>
 *
 */
#ifndef TINYDAV_CODEC_FSL_VPU_H264_H
#define TINYDAV_CODEC_FSL_VPU_H264_H

#include "tinydav_config.h"

#include "tinydav/codecs/h264/tdav_codec_h264_common.h"

TDAV_BEGIN_DECLS

TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_vpu_h264_base_plugin_def_t;
TINYDAV_GEXTERN const tmedia_codec_plugin_def_t *tdav_codec_fsl_vpu_h264_main_plugin_def_t;

static inline tsk_bool_t tdav_codec_h264_is_fsl_vpu_plugin(const tmedia_codec_plugin_def_t *plugin)
{
	return(plugin && ((plugin == tdav_codec_fsl_vpu_h264_base_plugin_def_t) || (plugin == tdav_codec_fsl_vpu_h264_main_plugin_def_t)));
}

TDAV_END_DECLS

#endif /* TINYDAV_CODEC_FSL_VPU_H264_H */
